=== debian/changelog ===
xrt (1:2.21.70-4) unstable; urgency=medium

  * Transition alveo libries for swemu and noop (Closes: #1125292)

 -- Mario Limonciello <superm1@debian.org>  Mon, 12 Jan 2026 09:22:08 -0600

xrt (1:2.21.70-3) unstable; urgency=medium

  * Only install swemu and noop on amd64

 -- Mario Limonciello <superm1@gmail.com>  Sun, 11 Jan 2026 13:38:42 -0600

xrt (1:2.21.70-2) unstable; urgency=medium

  * d/libxrt-dev.install: Add missing static libraries
    (Closes: #1124034)
  * d/control: Add libxrt-npu2, libxrt-alveo2, and python3-xrt to
    libxrt-dev deps

 -- Mario Limonciello <superm1@debian.org>  Sun, 04 Jan 2026 12:56:12 -0600

xrt (1:2.21.70-1) unstable; urgency=medium

  * New upstream version.  Fixes some launch issues for xrt-smi.
  * Add autopkgtest to try to ensure xrt-smi can be launched

 -- Mario Limonciello <superm1@debian.org>  Wed, 17 Dec 2025 11:28:51 -0600
